﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        oneStepTimer.Stop()
        oneStepTimer.Interval = 500

        DoubleBuffered = True

        creerTitres()

        gpeTitre0.Text = titres(0).nom
        gpeTitre1.Text = titres(1).nom
        gpeTitre2.Text = titres(2).nom
        gpeTitre3.Text = titres(3).nom

        lblOffre0.Text = titres(0).nom
        lblOffre1.Text = titres(1).nom
        lblOffre2.Text = titres(2).nom
        lblOffre3.Text = titres(3).nom

        ReDim offres(0)(100)
        ReDim offres(1)(100)
        ReDim offres(2)(100)
        ReDim offres(3)(100)

        nbOffres(0) = 0
        nbOffres(1) = 0
        nbOffres(2) = 0
        nbOffres(3) = 0

        creerInvestisseurs()

        distributionAleatoire()

        timestamp = 0
    End Sub

    Private Sub oneStep()
        Dim i As Integer
        Dim j As Integer

        If timestamp Mod 2 = 0 Then
            'Pour chaque investisseur, générer les nouvelles offres
            For i = 0 To nbInvestisseurs - 1
                For j = 0 To nbTitres - 1
                    faireOffre(j, i)
                Next
            Next
            'Trier les offres
            For i = 0 To nbTitres - 1
                trierOffres(offres(i), nbOffres(i))
            Next
            'Afficher les offres des investisseurs
            afficherOffres()
        Else
            'Mélanger les investisseurs pour plus d'équité
            Dim indices(nbInvestisseurs) As Integer
            For i = 0 To nbInvestisseurs - 1
                indices(i) = i
            Next
            melanger(indices, nbInvestisseurs)
            'Pour chaque investisseur, générer les achats
            For i = 0 To nbInvestisseurs - 1
                For j = 0 To nbTitres - 1
                    acheter(j, indices(i))
                Next
            Next
            'Trier les offres
            For i = 0 To nbTitres - 1
                trierOffres(offres(i), nbOffres(i))
            Next
            'Afficher les offres des investisseurs
            afficherOffres()
        End If

        nettoyerOffres()

        timestamp += 1
        Refresh()
    End Sub

    Private Sub melanger(ByRef T() As Integer, ByVal TailleT As Integer)
        Dim tmp As Integer
        Dim i As Integer
        Dim j As Integer
        For i = 0 To TailleT - 1
            j = rnd.Next(0, TailleT)
            tmp = T(i)
            T(i) = T(j)
            T(j) = tmp
        Next
    End Sub

    Private Sub dessinerTitres(ByVal iTitre As Integer, ByRef pnlTitre As Panel, ByRef lblVal As Label, ByRef lblMax As Label, ByRef lblMin As Label)
        Dim v_max As Integer
        Dim v_min As Integer

        v_min = valeurMin(iTitre)
        v_max = valeurMax(iTitre)

        lblVal.Text = titres(iTitre).valeur
        lblMax.Text = v_max
        lblMin.Text = v_min

        Dim i As Integer
        Dim pas As Integer
        pas = pnlTitre.Width / (TailleH + 1)

        Dim echelle As Integer
        If v_min <> v_max Then
            echelle = pnlTitre.Height / (v_max - v_min)
        Else
            echelle = 1
        End If


        Dim points(TailleH + 1) As Point
        For i = 0 To TailleH - 1
            points(i) = New Point(i * pas, pnlTitre.Height - (titres(iTitre).histoire(i) - v_min) * echelle)
        Next
        points(TailleH) = New Point(TailleH * pas, pnlTitre.Height - (titres(iTitre).valeur - v_min) * echelle)

        Dim g As Graphics
        g = pnlTitre.CreateGraphics

        Dim p As Pen
        p = New Pen(Brushes.Red)
        p.Width = 1
        i = 0
        While i < TailleH
            g.DrawLine(p, points(i), points(i + 1))
            i = i + 1
        End While
    End Sub

    Private Sub dessinerInvestisseur(ByVal iTitre As Integer, ByRef pnlInv As Panel, ByRef lblLiqI As Label)
        Dim inv As Investisseur
        inv = investisseurs(iTitre)

        lblLiqI.Text = inv.liquidites

        Dim g As Graphics
        g = pnlInv.CreateGraphics

        Dim p As Pen
        p = New Pen(Brushes.Red)
        p.Width = 1

        Dim i As Integer
        Dim x As Integer
        Dim y As Integer
        Dim h As Integer
        Dim w As Integer
        Dim b As Brush
        w = pnlInv.Width / nbTitres

        'Affichage des possesions
        For i = 0 To nbTitres
            h = (pnlInv.Height / nbActions) * inv.possessions(i)
            x = i * w
            y = pnlInv.Height - h
            If i Mod 2 = 0 Then
                b = Brushes.Blue
            Else
                b = Brushes.BlueViolet
            End If
            g.FillRectangle(b, x, y, w, h)
        Next

        'Affichage des actions mises en vente
        For i = 0 To nbTitres
            h = (pnlInv.Height / nbActions) * inv.offertes(i)
            x = i * w
            y = pnlInv.Height - h
            If i Mod 2 = 0 Then
                b = Brushes.Green
            Else
                b = Brushes.Gray
            End If
            g.FillRectangle(b, x, y, w - 5, h)
        Next
    End Sub

    Private Sub afficherOffres()
        'Effacer les ListBox
        lstOffres0.Items.Clear()
        lstOffres1.Items.Clear()
        lstOffres2.Items.Clear()
        lstOffres3.Items.Clear()
        'Remplir les ListBox
        Dim i As Integer
        For i = 0 To nbOffres(0) - 1
            lstOffres0.Items.Add(offreToString(offres(0)(i)))
        Next

        For i = 0 To nbOffres(1) - 1
            lstOffres1.Items.Add(offreToString(offres(1)(i)))
        Next

        For i = 0 To nbOffres(2) - 1
            lstOffres2.Items.Add(offreToString(offres(2)(i)))
        Next

        For i = 0 To nbOffres(3) - 1
            lstOffres3.Items.Add(offreToString(offres(3)(i)))
        Next

    End Sub

    Private Sub pnlTitre0_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlTitre0.Paint
        dessinerTitres(0, pnlTitre0, lblT0val, lblT0max, lblT0min)
    End Sub

    Private Sub pnlTitre1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlTitre1.Paint
        dessinerTitres(1, pnlTitre1, lblT1val, lblT1max, lblT1min)
    End Sub

    Private Sub pnlTitre2_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlTitre2.Paint
        dessinerTitres(2, pnlTitre2, lblT2val, lblT2max, lblT2min)
    End Sub

    Private Sub pnlTitre3_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlTitre3.Paint
        dessinerTitres(3, pnlTitre3, lblT3val, lblT3max, lblT3min)
    End Sub

    
    Private Sub pnlInv0_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlInv0.Paint
        dessinerInvestisseur(0, pnlInv0, lblLiqI0)
    End Sub

    Private Sub pnlInv1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlInv1.Paint
        dessinerInvestisseur(1, pnlInv1, lblLiqI1)
    End Sub

    Private Sub pnlInv2_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlInv2.Paint
        dessinerInvestisseur(2, pnlInv2, lblLiqI2)
    End Sub

    Private Sub pnlInv3_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlInv3.Paint
        dessinerInvestisseur(3, pnlInv3, lblLiqI3)
    End Sub

    Private Sub pnlInv4_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlInv4.Paint
        dessinerInvestisseur(4, pnlInv4, lblLiqI4)
    End Sub

    Private Sub pnlInv5_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlInv5.Paint
        dessinerInvestisseur(5, pnlInv5, lblLiqI5)
    End Sub

    Private Sub pnlInv6_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlInv6.Paint
        dessinerInvestisseur(6, pnlInv6, lblLiqI6)
    End Sub

    Private Sub pnlInv7_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlInv7.Paint
        dessinerInvestisseur(7, pnlInv7, lblLiqI7)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        oneStepTimer.Start()
    End Sub

    Private Sub oneStepTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles oneStepTimer.Tick
        oneStep()
    End Sub

    Private Sub btnPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPause.Click
        oneStepTimer.Stop()
    End Sub
End Class
