﻿Module Module1
    'Définitions des types de données
    Public Structure Titre
        Dim nom As String
        Dim histoire() As Integer
        Dim valeur As Integer
    End Structure

    Public Structure Investisseur
        Dim liquidites As Integer
        Dim possessions() As Integer 'L'indice de chaque case correspond à l'indice du titre dans le tableau titres()
        Dim offertes() As Integer    'L'indice de chaque case correspond à l'indice du titre dans le tableau titres()
        Dim strategieOffre As Integer
        Dim strategieAchat As Integer
    End Structure

    Public Structure Offre
        Dim iTitre As Integer           'L'indice du titre dans le tableau titres()
        Dim iInvestisseur As Integer    'L'indice de l'investisseur dans le tableau investisseurs()
        Dim quantite As Integer
        Dim prix As Integer
        Dim timestamp As Integer
    End Structure

    'Définitions des données globales
    Public timestamp As Integer         'Marque le nombre de pas de la simulation

    'Titres et actions
    Public nbTitres As Integer = 4      'Le nombre de titres sur la place boursière
    Public titres(nbTitres) As Titre    'Le tableau contenant les titres. On pourra accéder à un titre par son indice dans le tableau
    Public TailleH As Integer = 20      'Le nombre de valeurs dans l'historique des valeurs des titres
    Public nbActions As Integer = 1000  'Nombre d'actions de chaque titre

    'Investisseurs
    Public nbInvestisseurs = 8          'Le nombre d'investisseurs sur la place boursière
    Public investisseurs(nbInvestisseurs) As Investisseur   'Le tableau contenant les investisseurs. On pourra accéder à un investisseur par son indice dans le tableau

    'Offres - actions en vente
    Public offres(nbTitres)() As Offre  'Tableau à deux dimensions contenant toutes les offres par titre
    Public nbOffres(nbTitres) As Integer    'Tableau contenant le nombre d'offres par titre

    Public rnd As Random = New Random()  'Générateur de nombres aléatoires

    'Création des titres
    Public Sub creerTitres()
        'titre 0
        titres(0).nom = "Toto corp"
        titres(0).histoire = {90, 80, 65, 90, 115, 120, 125, 135, 135, 137, 138, 145, 142, 150, 140, 130, 125, 115, 110, 115}
        titres(0).valeur = 115

        'titre 1
        titres(1).nom = "Pipo inc"
        titres(1).histoire = {72, 76, 83, 89, 93, 100, 106, 109, 117, 123, 132, 138, 133, 127, 120, 108, 98, 92, 86, 89}
        titres(1).valeur = 90

        'titre 2
        titres(2).nom = "Bidule company"
        titres(2).histoire = {70, 62, 68, 72, 78, 86, 94, 88, 76, 67, 76, 84, 78, 69, 64, 62, 58, 64, 66, 68}
        titres(2).valeur = 70


        'titre 3
        titres(3).nom = "Maison Machin"
        titres(3).histoire = {70, 72, 69, 73, 78, 86, 94, 98, 99, 97, 95, 97, 99, 101, 104, 102, 107, 110, 111, 114}
        titres(3).valeur = 115
    End Sub

    'Création des investisseurs
    Public Sub creerInvestisseurs()
        Dim i As Integer
        For i = 0 To 7
            investisseurs(i).liquidites = 10000
            ReDim investisseurs(i).possessions(4)
            ReDim investisseurs(i).offertes(4)
            Dim j As Integer
            For j = 0 To 3
                investisseurs(i).offertes(j) = 0
            Next
        Next

        'Par investisseur, les indices des fonctions d'offre et d'achat à utiliser
        '0 : offreAleatoire, achatAleatoire
        '1 : maStrategieOffre, maStrategieAchat
        investisseurs(0).strategieOffre = 0
        investisseurs(0).strategieAchat = 0
        investisseurs(1).strategieOffre = 0
        investisseurs(1).strategieAchat = 0
        investisseurs(2).strategieOffre = 0
        investisseurs(2).strategieAchat = 0
        investisseurs(3).strategieOffre = 0
        investisseurs(3).strategieAchat = 0
        investisseurs(4).strategieOffre = 0
        investisseurs(4).strategieAchat = 0
        investisseurs(5).strategieOffre = 0
        investisseurs(5).strategieAchat = 0
        investisseurs(6).strategieOffre = 0
        investisseurs(6).strategieAchat = 0
        investisseurs(7).strategieOffre = 0
        investisseurs(7).strategieAchat = 0
    End Sub

    'Distribution aléatoire des actions aux investisseurs
    Public Sub distributionAleatoire()
        Dim aDistribuer As Integer
        Dim n As Integer
        Dim i As Integer
        For i = 0 To nbTitres - 1           'Pour chaque titre
            aDistribuer = nbActions         'Le nombre d'actions à distribuer est égal au nombre d'actions par titre
            Dim j As Integer
            j = 0
            While aDistribuer > 0           'Tant que je n'ai pas tout distribué
                n = rnd.Next(10, 201)       'Prendre de 10 à 200 actions actions
                If n > aDistribuer Then     'Pour les cas où il ne reste que peu d'actions à distribuer
                    n = aDistribuer
                End If
                investisseurs(j).possessions(i) = investisseurs(j).possessions(i) + n 'rajouter le nombre d'actions aux possessions
                aDistribuer = aDistribuer - n           'ne pas oublier d'enlever les actions distribuées
                j = (j + 1) Mod nbInvestisseurs         'passage à l'investisseur suivant, j boucle sur les indices des investisseurs
            End While
        Next
    End Sub

    'Retourne la valeur minimale du cours d'un titre d'indice iTitre en considérant le cours actuel et son historique des cours
    Public Function valeurMin(ByVal iTitre As Integer) As Integer
        Dim min As Integer

        min = titres(iTitre).valeur

        Dim i As Integer
        For i = 0 To TailleH - 1
            If titres(iTitre).histoire(i) < min Then
                min = titres(iTitre).histoire(i)
            End If
        Next

        Return min
    End Function

    'Retourne la valeur maximale du cours d'un titre d'indice iTitre en considérant le cours actuel et son historique des cours
    Public Function valeurMax(ByVal iTitre As Integer) As Integer
        Dim max As Integer

        max = titres(iTitre).valeur

        Dim i As Integer
        For i = 0 To TailleH - 1
            If titres(iTitre).histoire(i) > max Then
                max = titres(iTitre).histoire(i)
            End If
        Next

        Return max
    End Function

    'Permet de rajouter (ou non) une offre dans le tableau des offres. 
    'Cette offre est passée par l'investisseur d'indice iInvest et correspond au titre d'indice iTitre
    Public Sub offreAleatoire(ByVal iTitre As Integer, ByVal iInvest As Integer)
        Dim n As Double
        n = rnd.NextDouble()
        If n > 0.4 Then  '40% je ne fais rien, 60% je vends
            'Je ne peux poser une offre que si il me reste des actions disponibles
            Dim nDisponibles As Integer
            nDisponibles = investisseurs(iInvest).possessions(iTitre) - investisseurs(iInvest).offertes(iTitre)
            If nDisponibles > 0 Then
                Dim o As Offre
                o.iInvestisseur = iInvest
                o.iTitre = iTitre

                'Vente d'une portion des actions disponibles
                'Si moins de 10 actions disponibles
                If nDisponibles <= 10 Then
                    o.quantite = nDisponibles
                Else 'sinon une quantité aléatoire entre 10 et nDisponibles
                    o.quantite = rnd.Next(10, nDisponibles + 1)
                End If
             
                'Ne pas oublier de mettre à jour l'investisseur
                investisseurs(iInvest).offertes(iTitre) = investisseurs(iInvest).offertes(iTitre) + o.quantite

                'Prix de la vente (+ ou - 5% de la valeur actuelle)
                Dim pmin As Integer
                Dim pmax As Integer
                pmin = titres(iTitre).valeur * 0.95
                pmax = titres(iTitre).valeur * 1.05
                o.prix = rnd.Next(pmin, pmax + 1)

                'Indiquer le temps de passage de l'offre
                o.timestamp = timestamp

                'Rajouter l'offre dans le tableau des offres
                offres(iTitre)(nbOffres(iTitre)) = o
                nbOffres(iTitre) = nbOffres(iTitre) + 1
            End If
        End If
    End Sub

    'Trie un tableau d'offres en fonction des prix croissants
    Public Sub trierOffres(ByRef T() As Offre, ByVal TailleT As Integer)
        'Tri à bulle croissant
        Dim triees As Boolean = False
        Dim i As Integer
        Dim tmp As Offre
        While triees = False
            triees = True
            For i = 0 To TailleT - 2
                If T(i).prix > T(i + 1).prix Then 'On trie par rapport aux prix des offres
                    tmp = T(i)
                    T(i) = T(i + 1)
                    T(i + 1) = tmp
                    triees = False
                End If
            Next
        End While
    End Sub

    'Permet de retirer du tableau d'offres global l'offre d'indice iOffre concernant le titre d'indice iTitre
    Public Sub retirerOffre(ByVal iTitre As Integer, ByVal iOffre As Integer)
        Dim i As Integer

        'mettre à jour l'investisseur : retirer des actions offerts la quantité d'actions concernées par l'offre
        investisseurs(offres(iTitre)(iOffre).iInvestisseur).offertes(iTitre) = investisseurs(offres(iTitre)(iOffre).iInvestisseur).offertes(iTitre) - offres(iTitre)(iOffre).quantite

        'Faire un décalage à gauche pour retirer effectivement l'offre du tableau des offres
        For i = iOffre To nbOffres(iTitre) - 2
            offres(iTitre)(i) = offres(iTitre)(i + 1)
        Next

        'Ne pas oublier de mettre à jour la taille de la colonne des offres correspondant à iTitre
        nbOffres(iTitre) = nbOffres(iTitre) - 1
    End Sub

    'Nettoie les tableaux d'offres en éléminant les offres présentent depuis plus de 30 pas de simulation
    Public Sub nettoyerOffres()
        Dim i As Integer
        Dim j As Integer
        For i = 0 To nbTitres - 1
            j = 0
            While j < nbOffres(i)           'Attention : le nombre d'offres évolue au fur et à mesure des retraits - boucle pour déconseillée ...
                If timestamp - offres(i)(j).timestamp > 30 Then
                    retirerOffre(i, j)
                Else
                    j = j + 1 'Je passe à l'offre suivante si je n'ai rien retiré (quand je retire, l'offre d'indice j est automatiquement remplacée par la suivante à cause du décalage à gauche).
                End If
            End While
        Next
    End Sub

    'Transforme une offre o en chaîne de caractères
    Public Function offreToString(ByRef o As Offre) As String
        Dim s As String
        s = "<" + Str(o.iTitre) + ";" + Str(o.iInvestisseur) + ";" + Str(o.quantite) + ";" + Str(o.prix) + ">"
        Return s
    End Function

    'Permet de sélection le sous-programme d'offre pour le titre d'indice iTitre en fonction de la stratégie de l'investissseur d'indice iInvest
    Public Sub faireOffre(ByVal iTitre As Integer, ByVal iInvest As Integer)
        Dim strat As Integer
        strat = investisseurs(iInvest).strategieOffre
        Select Case strat
            Case 0
                offreAleatoire(iTitre, iInvest)
            Case 1
                maStrategieOffre(iTitre, iInvest)
            Case Else
                offreAleatoire(iTitre, iInvest)
        End Select
    End Sub

    'Permet de sélection le sous-programme d'achat pour le titre d'indice iTitre en fonction de la stratégie de l'investissseur d'indice iInvest
    Public Sub acheter(ByVal iTitre As Integer, ByVal iInvest As Integer)
        Dim strat As Integer
        If nbOffres(iTitre) > 0 Then
            strat = investisseurs(iInvest).strategieAchat
            Select Case strat
                Case 0
                    achatAleatoire(iTitre, iInvest)
                Case 1
                    maStrategieAchat(iTitre, iInvest)
                Case Else
                    achatAleatoire(iTitre, iInvest)
            End Select
        End If
    End Sub
    'Permet à l'investisseur d'indice iInvest d'acheter (ou non) des actions du titre d'indice iTitre
    Public Sub achatAleatoire(ByVal iTitre As Integer, ByVal iInvest As Integer)
        
    End Sub

    'Retourne le coût d'un achat de nActions du titre d'indice iTitre
    Public Function evaluerCoutAchat(ByVal iTitre As Integer, ByVal nActions As Integer) As Integer
        Dim cout As Integer
       
        Return cout
    End Function

    'Effectue la transaction entre l'acheteur d'indice iInvest et les investisseurs concernés par les offres opur nActions du titre d'indice iTitre.
    'Retourne le dernier prix constaté lors dela transaction.
    Public Function effectuerTransaction(ByVal iTitre As Integer, ByVal iInvest As Integer, ByVal nActions As Integer) As Integer
        Dim dernierPrix As Integer

        Return dernierPrix
    End Function

    'Met à jour le titre d'indice iTitre après une transaction terminée au prix dernierPrix
    Public Sub majTitre(ByVal iTitre, ByVal dernierPrix)

    End Sub

    'Permet de rajouter (ou non) une offre dans le tableau des offres. 
    'Cette offre est passée par l'investisseur d'indice iInvest et correspond au titre d'indice iTitre
    Public Sub maStrategieOffre(ByVal iTitre As Integer, ByVal iInvest As Integer)
       
    End Sub
    'Permet à l'investisseur d'indice iInvest d'acheter (ou non) des actions du titre d'indice iTitre
    Public Sub maStrategieAchat(ByVal iTitre As Integer, ByVal iInvest As Integer)
  
    End Sub

End Module
